VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="_site"


################
# Main targets #
################

{% include "./fragments/node.earth" %}



build:
    ARG yama_env="production"
    FROM +node-base
    WORKDIR /workdir

    COPY . .
    # NOTE: to optimize your builds even further, consider first COPY-ing the assets,
    # RUN your build steps (tailwind, vite, esbuild...). Only then, COPY the contents
    # and run eleventy. Doing this leverages Earthly's build cache, as your content
    # is more likely to change than your code assets.


    ENV YAMA_ENV=$yama_env

    # ... add more if needed, for example:
    # RUN yarn run build-tailwind
    RUN npx @11ty/eleventy


    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir



##################
# Helper targets #
##################

{% include "./fragments/node-helpers.earth" %}

# Run `yarn run dev` with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=8080
    ARG container_name="earthly-dev-server"

    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+node-base
            RUN docker run --rm -i \
                        --volume="$PWD":/workdir:Z \
                        --publish $port:8080 \
                        --name="$container_name" \
                        earthly-dev-server-image \
                        yarn run dev --port=8080
        END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop $container_name



################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
